<template>
    <div>
        <v-card elevation="1" class="admin-content">
            <v-card-title>
                Liste des types de soins
                <v-divider class="ml-4 mr-2" inset vertical></v-divider>
                <v-col cols="12" md="4">
                    <v-text-field
                        v-model="search"
                        append-icon="mdi-magnify"
                        label="Rechercher un type de soin"
                        single-line
                        hide-details
                    />
                </v-col>
                <v-divider class="ml-4 mr-6" inset vertical></v-divider>
                <v-btn
                    color="secondary"
                    @click="dialogNewCareType = true"
                >
                    <v-icon left>
                        mdi-plus
                    </v-icon>
                    Ajouter
                </v-btn>
                <v-dialog
                    v-model="dialogNewCareType"
                    max-width="500px"
                >
                    <v-card>
                        <v-card-title>
                            <span class="headline">Ajout de type de soin</span>
                        </v-card-title>
                         <v-form
                            v-model="isFormValid"
                            ref="newCareTypeForm"
                            @submit.prevent="submitNewCareTypeForm"
                        >
                        <v-card-text>
                            <v-container>
                                <v-row>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCareType.label"
                                            label="Label"
                                            :rules="[$utils.rules.required]"
                                            :counter="32"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCareType.description"
                                            :rules="[$utils.rules.required]"
                                            label="Description"
                                            :counter="100"
                                        ></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn
                                color="blue darken-1"
                                text
                                @click="dialogNewCareType = false"
                            >
                                Annuler
                            </v-btn>
                            <v-btn
                                color="blue darken-1"
                                type="submit"
                                :disabled="!isFormValid"
                                text
                            >
                                Ajouter
                            </v-btn>
                        </v-card-actions>
                        </v-form>
                    </v-card>
                </v-dialog>
                <v-dialog v-model="dialogDeleteCareType" max-width="500px">
                    <v-card>
                        <v-card-title class="headline">Etes-vous sûr de vouloir supprimer ?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="closeDelete">Annuler</v-btn>
                            <v-btn color="blue darken-1" text @click="confirmDeleteCareTypeDialog">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-card-title>
            <v-data-table
                :headers="careTypeTableHeaders"
                :items="careTypes"
                :search="search"
                :loading="loading"
                :items-per-page="10"
                no-results-text="Aucun résultat n'a été trouvé pour votre recherche"	
                no-data-text="Il n'y a pas de données disponibles"	
                loading-text="Les données sont en cours de chargement"
            >   
                <template v-slot:[`item.actions`]="{item}">
                    <v-icon
                        class="mr-2"
                        @click="editCareType(item.id)"
                    >
                        mdi-pencil
                    </v-icon>
                    <v-icon
                        @click="deleteCareTypeDialog(item.id)"
                    >
                        mdi-delete
                    </v-icon>
                </template>
                
            </v-data-table>
        </v-card>
        <v-snackbar
            v-model="careTypesSnackbar"
            :timeout="3000"
            :color="snackbarColor"
        >   
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="white"
                    text
                    v-bind="attrs"
                    @click="careTypesSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'CareTypes',
    data: () => ({
        search: '',
        dialogNewCareType: false,
        dialogDeleteCareType: false,
        currentCareTypeId: null,
        careTypesSnackbar: false,
        snackbarMessage: '',
        snackbarColor: '',
        loading: false,
        isFormValid: true,
        newCareType: {
            label: '',
            description: '',
        },
    }),
    methods: {
        ...mapActions(['loadCareTypes', 'deleteCareType', 'addCareType']),
        editCareType(careTypeId) {
            this.$router.push({name: 'CareTypeDetail', params: {careTypeId}})
        },
        deleteCareTypeDialog(careTypeId) {
            this.dialogDeleteCareType = true
            this.currentCareTypeId = careTypeId;
        },
        closeDelete() {
            this.dialogDeleteCareType = false;
            this.currentCareTypeId = null;
        },
        confirmDeleteCareTypeDialog() {
            this.deleteCareType(this.currentCareTypeId)
                .then(() => {
                    this.dialogDeleteCareType = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le type de soin a été supprimé avec succès';
                    this.careTypesSnackbar = true;
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.careTypesSnackbar = true;
                });
        },
        submitNewCareTypeForm() {
            this.addCareType(this.newCareType)
                .then(() => {
                    this.dialogNewCareType = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le nouveau type de soin a été ajouté avec succès';
                    this.careTypesSnackbar = true;
                    this.$refs.newCareTypeForm.reset();
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.careTypesSnackbar = true;
                })
        },
        loadingCareTypes() {
            if (this.careTypes === undefined || this.careTypes.length === 0) {
                this.loading = true;
                this.loadCareTypes()
                    .then(() => this.loading = false);
            }
        }
    },
    computed: {
        careTypeTableHeaders() {  
            return [
                {text: 'Label', align: 'start', value: 'label'},
                {text: 'Description', value: 'description'},
                {text: 'Actions', value: 'actions', sortable: false},
            ]
        },
        ...mapGetters(['getCrudError', 'careTypes'])
    },
    mounted() {
        this.loadingCareTypes();
    }
}
</script>